// --------------------------------- Some Values
var rememberedUnits = []
var anchorPositions = [AnchorPosition.TOPLEFT,
AnchorPosition.TOPCENTER, AnchorPosition.TOPRIGHT,
AnchorPosition.MIDDLELEFT, AnchorPosition.MIDDLECENTER,
AnchorPosition.MIDDLERIGHT, AnchorPosition.BOTTOMLEFT,
AnchorPosition.BOTTOMCENTER, AnchorPosition.BOTTOMRIGHT
]
// --------------------------------- Prototype Extensions

Selection = function () { }
Selection.prototype.active = function () {
  try { return (this.bounds) ? true : false; }
  catch (e) { return false; }
}

// --------------------------------- Action Manager Code Basics

function cTID(charID) {
  return charIDToTypeID(charID);
}
function sTID(stringID) {
  return stringIDToTypeID(stringID);
}
function tSID(typeID) {
  return typeIDToStringID(typeID);
}

var idnull = cTID("null")
var idLyr = cTID("Lyr ") // Layer
var idLyrI = cTID("LyrI") // LayerID
var idOrdn = cTID("Ordn") // Ordinal
var idTrgt = cTID("Trgt") // TargetEnum
var idsetd = cTID("setd") // set
var idPrpr = cTID("Prpr") // property
var idLefx = cTID("Lefx") // LayerEffects
var idNm = cTID("Nm  ") // Name
var idClr = cTID("Clr ") // Color
var idRGBC = cTID("RGBC") // RGBColor
var idRd = cTID("Rd  ") // red
var idGrn = cTID("Grn ") // green
var idBl = cTID("Bl  ") // blue
var idScl = cTID("Scl ") // scale
var idPrc = cTID("#Prc") // percent
var idT = cTID("T   ") // to
var idSoFi = cTID("SoFi") // SolidFill
var idMd = cTID("Md  ") // Mode
var idBlnM = cTID("BlnM") // BlendMode
var idNrml = cTID("Nrml") // Normal
var idOpct = cTID("Opct") // Opacity
var idChnl = cTID("Chnl") // Channel
var idfsel = cTID("fsel") // Selection
var idPxl = cTID("#Pxl") // Pixel
var idTop = cTID("Top ") // Top
var idLeft = cTID("Left") // Left
var idBtom = cTID("Btom") // Bottom
var idRght = cTID("Rght") // Right
var idRctn = cTID("Rctn") // Rectangle
var idMk = cTID("Mk  ") // make
var idmove = cTID("move") // move
var idPstn = cTID("Pstn") // Position
var idOrnt = cTID("Ornt") // Orientation
var idNw = cTID("Nw  ") // New
var idMsk = cTID("Msk ") // Mask
var idOfst = cTID("Ofst") // Offset
var idHrzn = cTID("Hrzn") // Horizontal
var idVrtc = cTID("Vrtc") // Vertical
var idHrzL = cTID("HrzL") // horizontal Location
var idVrtL = cTID("VrtL") // vertical Location
var idNone = cTID("None") // None
var idenab = cTID("enab") // enabled
var iduglg = cTID("uglg") // Use global lighting angle
var idlagl = cTID("lagl") // Local lightning angle
var idDstn = cTID("Dstn") // Distance
var idblur = cTID("blur") // Blur
var idNose = cTID("Nose") // Noise
var idDrSh = cTID("DrSh") // DropShadow
var idAntA = cTID("AntA") // AntiAlias
var idCkmt = cTID("Ckmt") // Choke Matte
var idGsnB = cTID("GsnB") // GaussianBlur
var idRds = cTID("Rds ") // Radius
var idMtnB = cTID("MtnB") // MotionBlur
var idAng = cTID("#Ang") // Angle Unit
var idAngl = cTID("Angl") // Angle
var idslct = cTID("slct") // select
var idBckw = cTID("Bckw") // backwards enum
var idFrwr = cTID("Frwr") // forwards enum
var idMkVs = cTID("MkVs") // make visible
var idPath = cTID("Path") // Path
var idDcmn = cTID('Dcmn') // Document
var idNxt = cTID("Nxt ") // next
var idPrvs = cTID("Prvs") // previous
var idAdjs = cTID("Adjs") // Adjustment
var idWdth = cTID("Wdth") // Width
var idHght = cTID("Hght") // Height
var idCnvS = cTID("CnvS") // Canvas
var idBttm = cTID("Bttm") // Botton Enum
var idCntr = cTID("Cntr") // Center
var idDocI = cTID("DocI") // Document ID
var idBckg = cTID("Bckg") // Background
var idAmnt = cTID("Amnt") // Amount
var idRslt = cTID("Rslt") // Resolution
var idVsbl = cTID("Vsbl") // visible
var idShw = cTID("Shw ") // show
var idTglO = cTID("TglO") // Toggle Options Pallette
var idUsng = cTID("Usng") // using
var idPnt = cTID("Pnt ") // paint
var idPthp = cTID("Pthp") // path point
var idAnch = cTID("Anch") // anchor
var idClsp = cTID("Clsp") // closed subpath
var idPaCm = cTID("PaCm") // path component
var idSbpl = cTID("Sbpl") // subpaths list
var idSbpL = cTID("SbpL") // subpaths list key
var idAdd = cTID("Add ") // add
var idPts = cTID("Pts ") // points
var idPath = cTID("Path") // Path
var idDlt = cTID("Dlt ") // delete
var idcut = cTID("cut ") // cut
var idpast = cTID("past") // paste
var idType = cTID("Type") // type
var idShp = cTID("Shp ") // shape
var idcopy = cTID("copy") // copy
var idpast = cTID("past") // paste

var idpresent = sTID("present")
var idsolidColorLayer = sTID("solidColorLayer")
var idcontentLayer = sTID("contentLayer")
var idbounds = sTID('bounds')
var idlayerConceals = sTID("layerConceals")
var idshowInDialog = sTID("showInDialog")
var idlayerSection = sTID('layerSection')
var idselectionModifier = sTID("selectionModifier")
var idselectionModifierType = sTID("selectionModifierType")
var idaddToSelection = sTID("addToSelection")
var idnumberOfLayers = sTID("numberOfLayers")
var idbackground = sTID("background")
var idname = sTID('name')
var idartboard = sTID("artboard");
var idlayerID = sTID('layerID')
var idlayerKind = sTID('layerKind')
var idTargetLayers = sTID('targetLayers');
var idcanvasExtensionColor = sTID("canvasExtensionColor");
var idcanvasExtensionColorType = sTID("canvasExtensionColorType");
var idcontentAware = sTID("contentAware");
var idframedGroupSection = sTID("framedGroupSection");
var idframedGroupRect = sTID("framedGroupRect");
var idclassFloatRect = sTID("classFloatRect");
var idshapeClipboardOperation = sTID("shapeClipboardOperation");

function layerDescById_with_idnull(id) {
  var desc = new ActionDescriptor()
  var ref = new ActionReference()
  ref.putIdentifier(idLyr, id)
  desc.putReference(idnull, ref)
  return desc
}

function layerDescByIdx_with_idnull(index) {
  var desc = new ActionDescriptor()
  var ref = new ActionReference()
  ref.putIndex(idLyr, index)
  desc.putReference(idnull, ref)
  return desc
}

function layerDescByIdx(index) {
  var ref = new ActionReference();
  ref.putIndex(idLyr, index)
  var desc = executeActionGet(ref)
  return desc
}

function layerDescById(id) {
  var ref = new ActionReference();
  ref.putIdentifier(idLyr, id)
  var desc = executeActionGet(ref)
  return desc
}

function targetLayerRef() {
  var ref = new ActionReference()
  ref.putEnumerated(idLyr, idOrdn, idTrgt)
  return ref
}

function targetLayerDescriptor() {
  var desc = new ActionDescriptor()
  desc.putReference(idnull, targetLayerRef())
  return desc
}

function targetLayerFxDescriptor() {
  var desc = new ActionDescriptor();
  var ref = new ActionReference();
  ref.putProperty(idPrpr, idLefx);
  ref.putEnumerated(idLyr, idOrdn, idTrgt);
  desc.putReference(idnull, ref);
  return desc
}

function contentLayerDescriptor() {
  var desc = new ActionDescriptor();
  var ref = new ActionReference();
  ref.putClass(idcontentLayer);
  desc.putReference(idnull, ref);
  return desc
}

function selectionDescriptor() {
  var desc = new ActionDescriptor();
  var ref = new ActionReference();
  ref.putProperty(idChnl, idfsel);
  desc.putReference(idnull, ref);
  return desc
}

function lowerLayerDescriptor() {
  var desc = new ActionDescriptor();
  var ref = new ActionReference();
  ref.putEnumerated(idLyr, idOrdn, idBckw);
  desc.putReference(idnull, ref);
  return desc;
}

function upperLayerDescriptor() {
  var desc = new ActionDescriptor();
  var ref = new ActionReference();
  ref.putEnumerated(idLyr, idOrdn, idFrwr);
  desc.putReference(idnull, ref);
  return desc;
}

function activeDocDescriptor() {
  var ref = new ActionReference();
  ref.putEnumerated(idDcmn, idOrdn, idTrgt);
  return executeActionGet(ref);
}

function targetPathDescriptor() {
  var desc = new ActionDescriptor();
  var ref = new ActionReference();
  ref.putEnumerated(idPath, idOrdn, idTrgt);
  desc.putReference(idnull, ref);
  return desc
}

// --------------------------------- Reference Conversions

function layersToIds(layers) {
  var ids = []
  for (var i = 0; i < layers.length; i++) {
    ids.push(layers[i].id)
  }
  return ids
}

function getIndex(layer) {
  return getIndexById(layer.id)
}

function getIndexById(id) {
  var desc = layerDescById(id)
  var idx = desc.getInteger(cTID('ItmI'))
  return backgroundExists() ? idx - 1 : idx
}

function backgroundExists() {
  try {
    var bg = app.activeDocument.backgroundLayer
    return true
  } catch (e) { return false }
}

function getNameById(id) {
  var desc = layerDescById(id)
  return desc.getString(idNm)
}

function getActiveLayerName() {
  var ref = new ActionReference();
  ref.putProperty(idPrpr, idNm);
  ref.putEnumerated(idLyr, idOrdn, idTrgt);
  return executeActionGet(ref).getString(idNm);
}

function getActiveLayerKind() {
  var ref = new ActionReference();
  ref.putProperty(idPrpr, idlayerKind);
  ref.putEnumerated(idLyr, idOrdn, idTrgt);
  return executeActionGet(ref).getInteger(idlayerKind)
}

function getActiveLayerIndex() {
  if (app.activeDocument.artLayers.length < 2) return 1;
  var idItmI = cTID("ItmI");
  var ref = targetLayerRef()
  var idx = executeActionGet(ref).getInteger(cTID("LyrI"));
  ref = new ActionReference();
  ref.putProperty(cTID("Prpr"), idItmI);
  ref.putIdentifier(idLyr, idx);
  idx = executeActionGet(ref).getInteger(idItmI);
  if (idx) return idx;
  return 0;
}

function getLayerIdByIndex(index) {
  var ref = new ActionReference();
  ref.putIndex(idLyr, index)
  var desc = executeActionGet(ref)
  return desc.getInteger(cTID('LyrI'));
};

function getActiveLayerID() {
  var ref = new ActionReference();
  ref.putProperty(idPrpr, idLyrI);
  ref.putEnumerated(idLyr, idOrdn, idTrgt);
  return executeActionGet(ref).getInteger(idLyrI);
}

function getProperty(desc, propertyId) {
  var dataType = desc.getType(propertyId);
  switch (dataType) {
    case DescValueType.INTEGERTYPE:
      return desc.getInteger(propertyId);
    case DescValueType.ALIASTYPE:
      return desc.getPath(propertyId);
    case DescValueType.BOOLEANTYPE:
      return desc.getBoolean(propertyId);
    case DescValueType.BOOLEANTYPE:
      return desc.getBoolean(propertyId);
    case DescValueType.UNITDOUBLE:
      return desc.getUnitDoubleValue(propertyId);
    case DescValueType.STRINGTYPE:
      return desc.getString(propertyId);
    case DescValueType.OBJECTTYPE:
      return desc.getObjectValue(propertyId);
    case DescValueType.LISTTYPE:
      return desc.getList(propertyId);
    case DescValueType.ENUMERATEDTYPE:
      return desc.getEnumerationValue(propertyId);
  }
}

function alertDescKeys(desc) {
  var keys = []
  for (var i = 0; i < desc.count; i++) {
    keys.push(typeIDToStringID(desc.getKey(i)))
  }
  alert(keys.join())
}

// ---------------------------------- Utility Functions



// ------- Layer Pallette

function selectLayers(indices) {
  for (var i = 0; i < indices.length; i++) {
    selectLayerByIndex(indices[i], i)
  }
}

function selectLayersByIds(ids) {
  for (var i = 0; i < ids.length; i++) {
    selectLayerById(ids[i], i)
  }
}

function createFrame(bounds) {
  var idMk = cTID("Mk  ");
  var desc = new ActionDescriptor();
  var ref = new ActionReference();
  var idframedGroupSection = sTID("framedGroupSection");
  ref.putClass(idframedGroupSection);
  desc.putReference(idnull, ref);
  var idframedGroupRect = sTID("framedGroupRect");
  var desc2 = new ActionDescriptor();
  desc2.putDouble(idTop, bounds[1]);
  desc2.putDouble(idLeft, bounds[0]);
  desc2.putDouble(idBtom, bounds[3]);
  desc2.putDouble(idRght, bounds[2]);
  var idclassFloatRect = sTID("classFloatRect");
  desc.putObject(idframedGroupRect, idclassFloatRect, desc2);
  var idframedGroupType = sTID("framedGroupType");
  desc.putInteger(idframedGroupType, 1);
  executeAction(idMk, desc, DialogModes.NO);
}

function getActiveTextLayerRotation() {
  var ref = targetLayerRef()
  var desc = executeActionGet(ref).getObjectValue(sTID('textKey'))
  if (desc.hasKey(sTID('transform'))) {
    desc = desc.getObjectValue(sTID('transform'))
    var yy = desc.getDouble(sTID('yy'));
    var xy = desc.getDouble(sTID('xy'));
    return -angleFromMatrix(yy, xy);
  }
  return 0;
}

function selectLayerByIndex(index, add) {
  var desc = layerDescByIdx_with_idnull(index)
  selectByDesc(desc, add)
}

function selectLayerById(id, add) {
  var desc = layerDescById_with_idnull(id)
  selectByDesc(desc, add)
}

function selectByDesc(desc, add) {

  if (add) desc.putEnumerated(idselectionModifier, idselectionModifierType, idaddToSelection);
  desc.putBoolean(idMkVs, false);
  try {
    executeAction(idslct, desc, DialogModes.NO);
  } catch (e) { }
}

function makeActiveByIndex(index, makeVisible) {
  makeVisible = makeVisible || false
  var desc = layerDescByIdx_with_idnull(index)
  desc.putBoolean(cTID("MkVs"), makeVisible);
  executeAction(cTID("slct"), desc, DialogModes.NO);
}

function makeActiveById(id, makeVisible) {
  var desc = layerDescById_with_idnull(id)
  makeVisible = makeVisible | false
  desc.putBoolean(cTID("MkVs"), makeVisible);
  executeAction(cTID("slct"), desc, DialogModes.NO);
}

/**
 * Note: Changes the current layer selection
 * @param {*} indices 
 */
function getLayersByIndices(indices) {
  var doc = app.activeDocument
  var layers = []
  for (var i = 0; i < indices.length; i++) {
    makeActiveByIndex(indices[i], false)
    layers.push(doc.activeLayer)
  }
  return layers
}

function getSelectedLayersIds() {
  var ids = []
  try {
    var keyTargetLayersIds = sTID('targetLayersIDs')
    var keyHasBG = sTID('hasBackgroundLayer')
    var desc = activeDocDescriptor()
    if (desc.getInteger(idnumberOfLayers) == 0 && desc.getBoolean(keyHasBG)) {
      return [1]
    }
    var idsList = desc.getList(keyTargetLayersIds)
    for (var i = 0; i < idsList.count; i++) {
      ids.push(idsList.getReference(i).getIdentifier())
    }
  } catch (e) { }
  return ids
}

function getIdsByIndices(indices) {
  var ids = []
  for (var i = 0; i < indices.length; i++) {
    ids.push(getLayerIdByIndex(indices[i]))
  }
  return ids
}

function getSelectedLayersIndices() {
  var selectedLayers = [];
  try {
    var bgCount = 1;
    try {
      var test = app.activeDocument.backgroundLayer;
      bgCount = 0;
    } catch (e) { }

    var ref = new ActionReference();
    var keyTargetLayers = sTID('targetLayers');
    ref.putProperty(cTID('Prpr'), keyTargetLayers);
    ref.putEnumerated(cTID('Dcmn'), cTID('Ordn'), cTID('Trgt'));
    var desc = executeActionGet(ref);
    if (desc.hasKey(keyTargetLayers)) {
      var layersList = desc.getList(keyTargetLayers);
      for (var i = 0; i < layersList.count; i++) {
        var listRef = layersList.getReference(i);
        selectedLayers.push(listRef.getIndex() + bgCount);
      }
    }
  } catch (e) { }
  return selectedLayers;
}

function getSelectedLayers() {
  var allSelected = getLayersByIndices(getSelectedLayersIndices())
  for (var i = 0; i < allSelected.length; i++) {
    if (allSelected[i].typename == 'LayerSet') {
      var group = allSelected[i]
      for (var c = 0; c < group.layers.length; c++) {
        remove(allSelected, group.layers[c])
      }
    }
  }
  return allSelected
}

function anythingSelected() {
  var ref = new ActionReference();
  var keyTargetLayers = sTID('targetLayers');
  ref.putProperty(idPrpr, keyTargetLayers);
  ref.putEnumerated(idDcmn, idOrdn, idTrgt);
  var desc = executeActionGet(ref);
  return desc.hasKey(keyTargetLayers)
}

function moveLayerTo(layer, x, y, regX, regY) {
  if (isTransformable(layer)) {
    usePixelUnits()
    var _regX = regX ? regX : 0
    var _regY = regY ? regY : 0
    var xShift = !isNaN(x) ? Math.round(-(x - layer.bounds[0]) - _regX) : 0
    var yShift = !isNaN(y) ? Math.round(-(y - layer.bounds[1]) - _regY) : 0
    layer.translate(xShift, yShift)
    resetUnits()
  }
}

function isTransformable(layer) {
  var type = layer.kind
  var typeAllowed = type == LayerKind.NORMAL ||
    type == LayerKind.LAYER3D ||
    type == LayerKind.SMARTOBJECT ||
    type == LayerKind.VIDEO ||
    type == LayerKind.TEXT ||
    (type == LayerKind.SOLIDFILL && !solidFillIsFullsize(layer))
  return layer.typename == 'LayerSet' || typeAllowed
}

function solidFillIsFullsize(layer) {
  var docSize = _docSize()
  var bounds = pixelBounds(layer.bounds)
  var width = bounds[2] - bounds[0]
  var height = bounds[3] - bounds[1]
  return width == docSize.width && height == docSize.height
}

/**
 * 
 * @param {*} bounds [x1, y1, x2, y2]
 * @param {*} color 
 */
function createRectangle(bounds, color) {
  var desc = contentLayerDescriptor()
  var desc2 = new ActionDescriptor();
  var desc3 = new ActionDescriptor();
  var desc4 = new ActionDescriptor();
  desc4.putDouble(idRd, color.rgb.red);
  desc4.putDouble(idGrn, color.rgb.green);
  desc4.putDouble(idBl, color.rgb.blue);
  desc3.putObject(idClr, idRGBC, desc4);

  desc2.putObject(idType, idsolidColorLayer, desc3);

  var desc5 = new ActionDescriptor();
  var idunitValueQuadVersion = sTID("unitValueQuadVersion");
  desc5.putInteger(idunitValueQuadVersion, 1);
  desc5.putUnitDouble(idLeft, idPxl, bounds[0]);
  desc5.putUnitDouble(idTop, idPxl, bounds[1]);
  desc5.putUnitDouble(idRght, idPxl, bounds[2]);
  desc5.putUnitDouble(idBtom, idPxl, bounds[3]);
  desc2.putObject(idShp, idRctn, desc5);

  desc.putObject(idUsng, idcontentLayer, desc2);
  executeAction(idMk, desc, DialogModes.NO);
}

function setGroupedById(id) {
  var idGrpL = charIDToTypeID("GrpL");
  var desc = layerDescById_with_idnull(id)
  executeAction(idGrpL, desc, DialogModes.NO);
}

function deleteGroup(group, deleteContained) {
  var idDlt = charIDToTypeID("Dlt ");
  var desc = layerDescById_with_idnull(group.id)
  var iddeleteContained = stringIDToTypeID("deleteContained");
  desc.putBoolean(iddeleteContained, deleteContained);
  executeAction(idDlt, desc, DialogModes.NO);
}

function selectLowerLayer(add) {
  var desc = lowerLayerDescriptor()
  desc.putBoolean(idMkVs, false);
  if (add) desc.putEnumerated(idselectionModifier, idselectionModifierType, idaddToSelection);
  executeAction(idslct, desc, DialogModes.NO)
}

function selectUpperLayer(add) {
  var desc = upperLayerDescriptor()
  desc.putBoolean(idMkVs, false);
  if (add) desc.putEnumerated(idselectionModifier, idselectionModifierType, idaddToSelection);
  executeAction(idslct, desc, DialogModes.NO)
}

function moveActiveLayerToIndex(idx) {
  try {
    var desc = targetLayerDescriptor()
    var ref = new ActionReference();
    ref.putIndex(idLyr, idx);
    desc.putReference(idT, ref);
    desc.putBoolean(idAdjs, false);
    var idVrsn = charIDToTypeID("Vrsn");
    desc.putInteger(idVrsn, 5);
    executeAction(idmove, desc, DialogModes.NO);
  } catch (e) { }
}

function moveToIndexById(id, idx) {
  var desc = layerDescById_with_idnull(id)
  ref = new ActionReference();
  ref.putIndex(idLyr, idx);
  desc.putReference(idT, ref);
  desc.putBoolean(idAdjs, false);
  return executeAction(idmove, desc, DialogModes.NO);
}

function moveLayerIndexUp() {
  var desc = targetLayerDescriptor()
  var ref = new ActionReference();
  ref.putEnumerated(idLyr, idOrdn, idNxt);
  desc.putReference(idT, ref);
  executeAction(idmove, desc, DialogModes.NO);
}

function moveLayerIndexDown() {
  var desc = targetLayerDescriptor()
  var ref = new ActionReference();
  ref.putEnumerated(idLyr, idOrdn, idPrvs);
  desc.putReference(idT, ref);
  executeAction(idmove, desc, DialogModes.NO);
}

function selectAllLayers() {
  var idselectAllLayers = sTID("selectAllLayers");
  var desc = new ActionDescriptor();
  var ref = targetLayerRef()
  desc.putReference(idnull, ref);
  executeAction(idselectAllLayers, desc, DialogModes.NO);
}

function selectNoLayers() {
  var idselectNoLayers = sTID("selectNoLayers");
  var desc = targetLayerDescriptor()
  executeAction(idselectNoLayers, desc, DialogModes.NO);
}

function newGroupFromLayers() {
  var desc = new ActionDescriptor();
  var ref = new ActionReference();
  ref.putClass(sTID('layerSection'));
  desc.putReference(idnull, ref);
  var lref = targetLayerRef()
  desc.putReference(cTID('From'), lref);
  executeAction(cTID('Mk  '), desc, DialogModes.NO);
  return app.activeDocument.activeLayer
}

function getAllLayers(includeBackground, includeGroups) {
  var layers = []
  getLayersRecursively(app.activeDocument, layers, includeBackground, includeGroups)
  return layers
}

function getAllGroups() {
  var groups = []
  getGroupsRecursively(app.activeDocument, groups)
  return groups
}

function getGroupsRecursively(parent, groups) {
  var groupAmount = parent.layerSets.length
  for (var i = 0; i < groupAmount; i++) {
    var currGroup = parent.layerSets[i];
    groups.push(currGroup)
    getGroupsRecursively(currGroup, groups);
  }
  return groups;
}

function getLayerCount() {
  var ref = new ActionReference();
  ref.putEnumerated(idDcmn, idOrdn, idTrgt);
  var docDesc = executeActionGet(ref);
  return docDesc.getInteger(idnumberOfLayers);
}

function isLayerSetId(id) {
  var desc = layerDescById(id)
  var sectionType = typeIDToStringID(desc.getEnumerationValue(idlayerSection))
  return sectionType == "layerSectionStart"
}


function getAllLayerIds(includeGroups, includeBackground) {
  var layerCount = getLayerCount()
  var ids = []
  for (var i = 0; i <= layerCount; i++) {
    try {
      var ref = new ActionReference()
      ref.putIndex(idLyr, i)
      var layerDesc = executeActionGet(ref);
      var sectionType = typeIDToStringID(layerDesc.getEnumerationValue(idlayerSection))
      var isBackground = layerDesc.getBoolean(idbackground)
      isLayerSetStart = sectionType == "layerSectionStart"
      isLayerSetEnd = sectionType == "layerSectionEnd"

      var add = !isLayerSetEnd
        && (!isLayerSetStart || includeGroups)
        && (!isBackground || includeBackground)
      if (add) {
        ids.push(layerDesc.getInteger(idlayerID))
      }
    }
    catch (e) { }
  }
  return ids
}

function getAllGroupIds() {
  var layerCount = getLayerCount()
  var ids = []
  for (var i = 0; i <= layerCount; i++) {
    try {
      var ref = new ActionReference()
      ref.putIndex(idLyr, i)
      var layerDesc = executeActionGet(ref);
      var sectionType = typeIDToStringID(layerDesc.getEnumerationValue(idlayerSection))
      if (sectionType == "layerSectionStart") {
        ids.push(layerDesc.getInteger(idlayerID))
      }
    }
    catch (e) { }
  }
  return ids
}

function getLayersRecursively(parent, allLayers, includeBackground, includeGroups) {
  var layerAmount = parent.layers.length
  for (var i = 0; i < layerAmount; i++) {
    var currLayer = parent.layers[i];
    var isBG = currLayer.isBackgroundLayer
    var isArtlayer = currLayer.typename === "ArtLayer"
    var add = !isBG || (isBG && includeBackground)
    if (isArtlayer) {
      if (add) {
        allLayers.push(currLayer);
      }
    } else {
      if (includeGroups) {
        allLayers.push(currLayer);
      }
      getLayersRecursively(currLayer, allLayers, includeBackground, includeGroups);
    }
  }
  return allLayers;
}


/**
 * type: 'normal', 'smartobject', 'text', 'group', 'adjustment', 'shape'
 */
function selectLayersFromType(type) {
  var layers = getAllLayers(false, true)
  switch (type) {
    case 'normal':
      layers = layers.filter(isNormalLayer)
      break;
    case 'smartobject':
      layers = layers.filter(isSmartObjectLayer)
      break;
    case 'text':
      layers = layers.filter(isTextLayer)
      break;
    case 'group':
      layers = layers.filter(isLayerSet)
      break;
    case 'adjustment':
      layers = layers.filter(isAdjustmentLayer)
      break;
    case 'shape':
      layers = layers.filter(isShapeLayer)
      break;
  }

  if (layers.length == 0) {
    alert('There are no ' + type + ' layers in the document.')
    return
  }

  for (var i = 0; i < layers.length; i++) {
    var lay = layers[i]
    var desc = layerDescById_with_idnull(lay.id)
    if (i == 0) {
      selectByDesc(desc, false)
    } else {
      selectByDesc(desc, true)
    }
  }
}

function isArtLayer(layer) {
  return layer.typename == 'ArtLayer'
}

function isNormalLayer(layer) {
  return isArtLayer(layer)
    && (layer.kind == LayerKind.NORMAL
      || layer.kind == LayerKind.LAYER3D)
}

function isShapeLayer(layer) {
  return isArtLayer(layer)
    && layer.kind == LayerKind.SOLIDFILL
}

function isSmartObjectLayer(layer) {
  return isArtLayer(layer)
    && layer.kind == LayerKind.SMARTOBJECT
}

function isTextLayer(layer) {
  return isArtLayer(layer)
    && layer.kind == LayerKind.TEXT
}

function isAdjustmentLayer(layer) {
  return isArtLayer(layer)
    && (layer.kind == LayerKind.BLACKANDWHITE
      || layer.kind == LayerKind.BRIGHTNESSCONTRAST
      || layer.kind == LayerKind.CHANNELMIXER
      || layer.kind == LayerKind.COLORBALANCE
      || layer.kind == LayerKind.CURVES
      || layer.kind == LayerKind.EXPOSURE
      || layer.kind == LayerKind.GRADIENTFILL
      || layer.kind == LayerKind.GRADIENTMAP
      || layer.kind == LayerKind.HUESATURATION
      || layer.kind == LayerKind.INVERSION
      || layer.kind == LayerKind.LEVELS
      || layer.kind == LayerKind.PATTERNFILL
      || layer.kind == LayerKind.PHOTOFILTER
      || layer.kind == LayerKind.POSTERIZE
      || layer.kind == LayerKind.SELECTIVECOLOR
      || layer.kind == LayerKind.THRESHOLD
      || layer.kind == LayerKind.VIBRANCE)
}

function cutPixels() {
  executeAction(idcut, undefined, DialogModes.NO);
}

function pastePixels(inPlace) {
  inPlace = inPlace || false
  var desc = new ActionDescriptor();
  if (inPlace) {
    var idinPlace = sTID("inPlace");
    desc.putBoolean(idinPlace, true);
  }
  var idAntA = cTID("AntA");
  var idAnnt = cTID("Annt");
  var idAnno = cTID("Anno");
  desc.putEnumerated(idAntA, idAnnt, idAnno);
  var idAs = cTID("As  ");
  var idPxel = cTID("Pxel");
  desc.putClass(idAs, idPxel);
  executeAction(idpast, desc, DialogModes.NO);
}

function mergeDown() {
  var idMrgtwo = cTID("Mrg2");
  var desc = new ActionDescriptor();
  executeAction(idMrgtwo, desc, DialogModes.NO);
}

function duplicateActive() {
  var idCpTL = cTID("CpTL");
  executeAction(idCpTL, undefined, DialogModes.NO);
}

function duplicateActive2() {
  var idDplc = cTID("Dplc");
  var desc = new ActionDescriptor();
  var ref = new ActionReference();
  ref.putEnumerated(idLyr, idOrdn, idTrgt);
  desc.putReference(idnull, ref);
  var idVrsn = cTID("Vrsn");
  desc.putInteger(idVrsn, 5);
  var idIdnt = cTID("Idnt");
  var list = new ActionList();
  list.putInteger(629);
  desc.putList(idIdnt, list);
  executeAction(idDplc, desc, DialogModes.NO);
}

function duplicateWithName(name) {
  duplicateActive()
  var cpy = app.activeDocument.activeLayer
  cpy.name = name
  return cpy
}

function scaleActiveLayer(widthPercent, heightPercent, xOffset, yOffset, contentAware) {
  contentAware = contentAware || false
  var layerDesc = targetLayerDescriptor()
  var idTrnf = cTID("Trnf");
  var idFTcs = cTID("FTcs");
  var idQCSt = cTID("QCSt");
  var idQcsa = cTID("Qcsa");
  layerDesc.putEnumerated(idFTcs, idQCSt, idQcsa);
  var desc2 = new ActionDescriptor();

  xOffset = xOffset == undefined ? 0 : xOffset
  yOffset = yOffset == undefined ? 0 : yOffset

  desc2.putUnitDouble(idHrzn, idPxl, xOffset);
  desc2.putUnitDouble(idVrtc, idPxl, yOffset);
  layerDesc.putObject(idOfst, idOfst, desc2);
  var idIntr = cTID("Intr");
  var idIntp = cTID("Intp");
  var idBcbc = cTID("Bcbc");
  if (heightPercent) {
    var idHght = cTID("Hght");
    layerDesc.putUnitDouble(idHght, idPrc, heightPercent);
    layerDesc.putEnumerated(idIntr, idIntp, idBcbc);
  }
  if (widthPercent) {
    var idWdth = cTID("Wdth");
    layerDesc.putUnitDouble(idWdth, idPrc, widthPercent);
    layerDesc.putEnumerated(idIntr, idIntp, idBcbc);
  }

  if (contentAware) {
    layerDesc.putBoolean(idcontentAware, true);
    layerDesc.putDouble(idAmnt, 100);
  }

  /*
  var idwarp = sTID("warp");
  var warpDesc = new ActionDescriptor();
  var idwarpStyle = sTID("warpStyle");
  var idwarpNone = sTID("warpNone");
  warpDesc.putEnumerated(idwarpStyle, idwarpStyle, idwarpNone);

  var idwarpValue = sTID("warpValue");
  warpDesc.putDouble(idwarpValue, 0.000000);
  var idwarpPerspective = sTID("warpPerspective");
  warpDesc.putDouble(idwarpPerspective, 0.000000);
  var idwarpPerspectiveOther = sTID("warpPerspectiveOther");
  warpDesc.putDouble(idwarpPerspectiveOther, 0.000000);
  var idwarpRotate = sTID("warpRotate");
  var idOrnt = charIDToTypeID("Ornt");
  warpDesc.putEnumerated(idwarpRotate, idOrnt, idHrzn);
  var iduOrder = sTID("uOrder");
  warpDesc.putInteger(iduOrder, 4);
  var idvOrder = sTID("vOrder");
  warpDesc.putInteger(idvOrder, 4);
  layerDesc.putObject(idwarp, idwarp, warpDesc); */

  executeAction(idTrnf, layerDesc, DialogModes.NO);
}

function move(layerDesc, x, y) {
  var idmove = cTID("move");
  var idT = cTID("T   ");
  var desc = new ActionDescriptor();
  desc.putUnitDouble(idHrzn, idPxl, x);
  desc.putUnitDouble(idVrtc, idPxl, y);
  var idOfst = cTID("Ofst");
  layerDesc.putObject(idT, idOfst, desc);
  executeAction(idmove, layerDesc, DialogModes.NO);
}

function setFillOpacity(desc, percent) {
  var fill_desc = new ActionDescriptor();
  var idfillOpacity = sTID("fillOpacity");
  fill_desc.putUnitDouble(idfillOpacity, idPrc, percent);
  desc.putObject(idT, idLyr, fill_desc);
  executeAction(idsetd, desc, DialogModes.NO);
}

function rasterizeLayerStyle(desc) {
  var idrasterizeLayer = sTID("rasterizeLayer");
  var idWhat = cTID("What");
  var idrasterizeItem = sTID("rasterizeItem");
  var idlayerStyle = sTID("layerStyle");
  desc.putEnumerated(idWhat, idrasterizeItem, idlayerStyle);
  executeAction(idrasterizeLayer, desc, DialogModes.NO);
}

function rasterizeActiveLayer() {
  var idrasterizeLayer = sTID("rasterizeLayer");
  executeAction(idrasterizeLayer, targetLayerDescriptor(), DialogModes.NO);
}

function sendBackwards(desc) {
  var previous_ref = new ActionReference();
  var idPrvs = charIDToTypeID("Prvs");
  previous_ref.putEnumerated(idLyr, idOrdn, idPrvs);
  desc.putReference(idT, previous_ref);
  executeAction(idmove, desc, DialogModes.NO);
}

function getParentIndexById(id) {
  var idx = getIndexById(id)
  var nestedSets = 0;
  var layerCount = getNumberOfLayer();
  for (var i = idx; i <= layerCount; i++) {
    var layerSection = getLayerSectionByIndex(i);
    if (layerSection == 'layerSectionEnd') nestedSets++;
    if (layerSection == 'layerSectionStart' && nestedSets > 0) nestedSets--;
    if (layerSection == 'layerSectionStart' && nestedSets == 0) return i + 1;
  }
  function getLayerSectionByIndex(idx) {
    var ref = new ActionReference();
    ref.putProperty(idPrpr, idlayerSection);
    ref.putIndex(idLyr, idx);
    return typeIDToStringID(executeActionGet(ref).getEnumerationValue(idlayerSection));
  };
  function getNumberOfLayer() {
    var ref = new ActionReference();
    ref.putEnumerated(idDcmn, idOrdn, idTrgt);
    var desc = executeActionGet(ref);
    var numberOfLayer = desc.getInteger(cTID("NmbL"));
    return numberOfLayer;
  };
};

function reverseLayerOrder() {
  var idRvrs = charIDToTypeID("Rvrs");
  var desc = targetLayerDescriptor()
  executeAction(idRvrs, desc, DialogModes.NO);
}

function setActiveAsBackground() {
  var desc = new ActionDescriptor();
  var ref = new ActionReference();
  var idBckL = cTID("BckL");
  ref.putClass(idBckL);
  desc.putReference(idnull, ref);
  var idUsng = cTID("Usng");
  var ref2 = new ActionReference();
  ref2.putEnumerated(idLyr, idOrdn, idTrgt);
  desc.putReference(idUsng, ref2);
  executeAction(idMk, desc, DialogModes.NO);
}

function getLayerSetBounds(id) {
  var xMin, xMax, yMin, yMax
  var childIndices = getChildIndices(id, false)

  for (var i = 0; i < childIndices.length; i++) {
    var childID = getLayerIdByIndex(childIndices[i])
    if (!isLayerSetId(childID)) {
      var cBounds = getBoundsById(childID)
      xMin = xMin ? Math.min(xMin, cBounds[0]) : cBounds[0]
      xMax = xMax ? Math.max(xMax, cBounds[2]) : cBounds[2]
      yMin = yMin ? Math.min(yMin, cBounds[1]) : cBounds[1]
      yMax = yMax ? Math.max(yMax, cBounds[3]) : cBounds[3]
    }
  }
  return [xMin || 0, yMin || 0, xMax || 0, yMax || 0]
}

function setActiveLayerSize(fromSize, toSize, anchorIndexW, anchorIndexH, contentAware) {
  contentAware = contentAware || false
  var factorW = (toSize.width / fromSize.width) * 100
  var factorH = (toSize.height / fromSize.height) * 100
  var diffW = toSize.width - fromSize.width
  var diffH = toSize.height - fromSize.height
  var xOffset = 0, yOffset = 0
  var preventHalfPixelsX = diffW / 2
  var preventHalfPixelsY = diffH / 2

  switch (anchorIndexW) {
    case 1: xOffset = -diffW / 2; break;
    case 2: xOffset = -diffW; break;
    case 4: xOffset = -diffW / 2; break;
    case 5: xOffset = -diffW; break;
    case 7: xOffset = -diffW / 2; break;
    case 8: xOffset = -diffW; break;
    default: break;
  }
  switch (anchorIndexH) {
    case 3: yOffset = -diffH / 2; break;
    case 4: yOffset = -diffH / 2; break;
    case 5: yOffset = -diffH / 2; break;
    case 6: yOffset = -diffH; break;
    case 7: yOffset = -diffH; break;
    case 8: yOffset = -diffH; break;
    default: break;
  }
  scaleActiveLayer(factorW, factorH, Math.round(xOffset) + preventHalfPixelsX, Math.round(yOffset) + preventHalfPixelsY, contentAware)
}

function rasterizeBG() {
  var desc = new ActionDescriptor();
  var ref = new ActionReference();
  ref.putProperty(idLyr, idBckg);
  desc.putReference(idnull, ref);
  var desc2 = new ActionDescriptor();
  desc2.putUnitDouble(idOpct, idPrc, 100);
  desc2.putEnumerated(idMd, idBlnM, idNrml);
  desc.putObject(idT, idLyr, desc2);
  executeAction(idsetd, desc, DialogModes.NO);
}


function getSectionTypeByIndex(index) {
  var ref = new ActionReference();
  ref.putProperty(idPrpr, idlayerSection);
  ref.putIndex(idLyr, index);
  return typeIDToStringID(executeActionGet(ref).getEnumerationValue(idlayerSection));
}

function getLayerNameByIndex(index) {
  var ref = new ActionReference();
  ref.putProperty(idPrpr, idNm);
  ref.putIndex(idLyr, index);
  return executeActionGet(ref).getString(idNm);
}

function skipNestedSets(layerIndex) {
  var isEnd = false;
  layerIndex = backgroundExists() ? layerIndex - 2 : layerIndex;
  while (!isEnd) {
    layerIndex--;
    if (getSectionTypeByIndex(layerIndex) == 'layerSectionStart') layerIndex = skipNestedSets(layerIndex);
    isEnd = getLayerNameByIndex(layerIndex) == "</Layer group>" ? true : false;
  }
  return layerIndex - 1;
}

function getChildIndices(id, skipNested) {
  var layerSetIndex = getIndexById(id)
  var isEndOfSet = false;
  var childIndices = [];
  while (!isEndOfSet) {
    layerSetIndex--;
    if (getSectionTypeByIndex(layerSetIndex) == 'layerSectionStart' && skipNested) {
      layerSetIndex = skipNestedSets(layerSetIndex);
    }
    if (getSectionTypeByIndex(layerSetIndex) == undefined) break;
    isEndOfSet = getLayerNameByIndex(layerSetIndex) == "</Layer group>" ? true : false;
    if (!isEndOfSet) childIndices.push(layerSetIndex);
  }
  return childIndices;
}

function subPathToInfo(subPath) {
  var subPathInfo = new SubPathInfo();
  var points = []
  for (var i = 0; i < subPath.pathPoints.length; i++) {
    var p = subPath.pathPoints[i]
    points[i] = new PathPointInfo;
    points[i].kind = p.kind;
    points[i].anchor = p.anchor;
    points[i].leftDirection = p.leftDirection;
    points[i].rightDirection = p.rightDirection;
  }
  subPathInfo.closed = subPath.closed;
  subPathInfo.operation = subPath.operation;
  subPathInfo.entireSubPath = points;
  return subPathInfo
}

function createPathFromInfo(subPathInfo, name) {
  var name = name || 'custom path'
  return activeDocument.pathItems.add(name, [subPathInfo]);
}

function createPath(pointArray, name) {
  var name = name || 'custom path'
  var doc = app.activeDocument;
  var y = pointArray.length;
  var i = 0;

  var points = [];
  for (i = 0; i < y; i++) {
    points[i] = new PathPointInfo;
    points[i].kind = PointKind.CORNERPOINT;
    points[i].anchor = pointArray[i];
    points[i].leftDirection = points[i].anchor;
    points[i].rightDirection = points[i].anchor;
  }

  var subPathInfo = new SubPathInfo();
  subPathInfo.closed = true;
  subPathInfo.operation = ShapeOperation.SHAPEADD;
  subPathInfo.entireSubPath = points;
  return doc.pathItems.add(name, [subPathInfo]);
}

function createShapeFromActivePath() {
  var desc = new ActionDescriptor();
  var ref = new ActionReference();
  ref.putClass(idcontentLayer);
  desc.putReference(idnull, ref);
  var desc2 = new ActionDescriptor();
  var desc3 = new ActionDescriptor();
  // var desc4 = new ActionDescriptor();
  // desc4.putDouble(idRd, 0.000000); // R
  // desc4.putDouble(idGrn, 0.000000); // G
  // desc4.putDouble(idBl, 0.000000); // B
  // desc3.putObject(idClr, idRGBC, desc4);
  desc2.putObject(idType, idsolidColorLayer, desc3);
  desc.putObject(idUsng, idcontentLayer, desc2);
  executeAction(idMk, desc, DialogModes.NO);
}

function createShape(pointArray) {
  var pathItem = createPath(pointArray)
  createShapeFromActivePath()
  pathItem.remove();
}

function isVisible(id) {
  var ref = new ActionReference()
  ref.putProperty(idPrpr, idVsbl)
  ref.putIdentifier(idLyr, id)
  return executeActionGet(ref).getBoolean(idVsbl)
}

function isHidden(id) {
  return !isVisible(id)
}

function toggleOnlyActiveVisible() {
  var desc = new ActionDescriptor();
  var list = new ActionList();
  var ref = new ActionReference();
  ref.putEnumerated(idLyr, idOrdn, idTrgt);
  list.putReference(ref);
  desc.putList(idnull, list);
  desc.putBoolean(idTglO, true);
  executeAction(idShw, desc, DialogModes.NO);
}

function rectToFrame(name, bounds, shapePoints) {
  var desc = new ActionDescriptor();
  var frameRef = new ActionReference();
  frameRef.putClass(idframedGroupSection);
  desc.putReference(idnull, frameRef);

  var nameDesc = new ActionDescriptor();
  nameDesc.putString(idNm, name);
  desc.putObject(idUsng, idframedGroupSection, nameDesc);
  desc.putString(idNm, "Shape");

  var boundsDesc = new ActionDescriptor();
  boundsDesc.putDouble(idTop, bounds[1]);
  boundsDesc.putDouble(idLeft, bounds[0]);
  boundsDesc.putDouble(idBtom, bounds[3]);
  boundsDesc.putDouble(idRght, bounds[2]);

  desc.putObject(idframedGroupRect, idclassFloatRect, boundsDesc);
  var idframedGroupPathResolution = sTID("framedGroupPathResolution");
  desc.putDouble(idframedGroupPathResolution, 72.000000);

  var idframedGroupPath = sTID("framedGroupPath");
  var idpathComponents = sTID("pathComponents");
  var idshapeOperation = sTID("shapeOperation");

  var framedGroupPathDesc = new ActionDescriptor();
  var pathCompList = new ActionList();

  var shapeDesc = new ActionDescriptor();
  shapeDesc.putEnumerated(idshapeOperation, idshapeOperation, idAdd);

  var subPathList = new ActionList();
  var pathDesc = new ActionDescriptor();
  pathDesc.putBoolean(idClsp, true);
  var pathPointList = new ActionList();

  for (var i = 0; i < shapePoints.length; i++) {
    var pt = shapePoints[i]
    var pathPointDesc = new ActionDescriptor();
    var pointDesc = new ActionDescriptor();
    pointDesc.putUnitDouble(idHrzn, idPxl, pt[0]);
    pointDesc.putUnitDouble(idVrtc, idPxl, pt[1]);
    pathPointDesc.putObject(idAnch, idPnt, pointDesc);
    pathPointList.putObject(idPthp, pathPointDesc);
  }

  pathDesc.putList(idPts, pathPointList);
  subPathList.putObject(idSbpl, pathDesc);
  shapeDesc.putList(idSbpL, subPathList);

  pathCompList.putObject(idPaCm, shapeDesc);
  framedGroupPathDesc.putList(idpathComponents, pathCompList);
  var idpathClass = sTID("pathClass");
  desc.putObject(idframedGroupPath, idpathClass, framedGroupPathDesc);
  var idframedGroupType = sTID("framedGroupType");
  desc.putInteger(idframedGroupType, 4);
  var idLockPPI = sTID("LockPPI");
  desc.putBoolean(idLockPPI, false);
  var idPreferredResolution = sTID("PreferredResolution");
  desc.putDouble(idPreferredResolution, 300.000000);
  executeAction(idMk, desc, DialogModes.NO);
}

function deleteLayerMask() {
  var idDlt = cTID("Dlt ");
  var desc = new ActionDescriptor();
  var ref = new ActionReference();
  ref.putEnumerated(idChnl, idChnl, idMsk);
  desc.putReference(idnull, ref);
  executeAction(idDlt, desc, DialogModes.NO);
}

function vectorMaskFromCurrentPath() {
  var desc = new ActionDescriptor();
  var ref = new ActionReference();
  ref.putClass(idPath);
  desc.putReference(idnull, ref);
  var idAt = charIDToTypeID("At  ");
  var ref2 = new ActionReference();
  var idvectorMask = stringIDToTypeID("vectorMask");
  ref2.putEnumerated(idPath, idPath, idvectorMask);
  desc.putReference(idAt, ref2);
  var ref3 = new ActionReference();
  ref3.putEnumerated(idPath, idOrdn, idTrgt);
  desc.putReference(idUsng, ref3);
  executeAction(idMk, desc, DialogModes.NO);
}

function setActiveLayerName(name) {
  var desc = targetLayerDescriptor()
  var nameDesc = new ActionDescriptor();
  nameDesc.putString(idNm, name);
  desc.putObject(idT, idLyr, nameDesc);
  executeAction(idsetd, desc, DialogModes.NO);
}

function currentLayerProbablyPhoto() {
  toggleOnlyActiveVisible()
  var histogram = app.activeDocument.histogram
  toggleOnlyActiveVisible()
  var counts = {};
  for (var i = 0; i < histogram.length; i++) {
    counts[histogram[i]] = 1 + (counts[histogram[i]] || 0);
  }
  return Object.keys(counts).length > 100
}

function deleteActiveLayer() {
  var desc = targetLayerDescriptor()
  executeAction(idDlt, desc, DialogModes.NO);
}

function releaseClippingMask() {
  var idUngr = cTID("Ungr");
  var desc = targetLayerDescriptor()
  executeAction(idUngr, desc, DialogModes.NO);
}

function activateByIndex(index) {
  var desc = new ActionDescriptor();
  var ref = new ActionReference();
  ref.putIndex(idLyr, index);
  desc.putReference(idnull, ref);
  desc.putBoolean(idMkVs, false);
  executeAction(idslct, desc, DialogModes.NO);
}

function activateByName(name) {
  var desc = new ActionDescriptor();
  var ref = new ActionReference();
  ref.putName(idLyr, name);
  desc.putReference(idnull, ref);
  desc.putBoolean(idMkVs, false);
  executeAction(idslct, desc, DialogModes.NO);
}

function bringActiveToFront() {
  var desc = targetLayerDescriptor()
  var ref = new ActionReference();
  var idFrnt = charIDToTypeID("Frnt");
  ref.putEnumerated(idLyr, idOrdn, idFrnt);
  desc.putReference(idT, ref);
  executeAction(idmove, desc, DialogModes.NO);
}

function loopLayers(callback) {
  var layerCount = getLayerCount()
  var fix = backgroundExists() ? 0 : 1
  for (var i = 0 + fix; i <= layerCount; i++) {
    try {
      var ref = new ActionReference()
      ref.putIndex(idLyr, i)
      var layerDesc = executeActionGet(ref)
      callback.call(i, layerDesc);
    } catch (e) { }
  }
}

function getClippingGroups() {
  var clipGroups = {}
  var previous = {}
  var lastClippingBase
  loopLayers(function (desc) {
    var id = desc.getInteger(idlayerID)
    var clippingDown = getProperty(desc, sTID('group'))

    if (clippingDown) {
      if (previous.clippingDown) {
        clipGroups[lastClippingBase].push(id)
      }
      else {
        clippingLayers = [id]
        lastClippingBase = previous.id
        clipGroups[lastClippingBase] = clippingLayers
      }
    }
    previous.id = id
    previous.clippingDown = clippingDown
  })
  return clipGroups
}

function layerInfoByID(id, stringIds) {
  var info = {}
  var desc = layerDescById(id)

  for (var i = 0; i < stringIds.length; i++) {
    var stringId = stringIds[i]
    info[stringId] = getProperty(desc, sTID(stringId))
  }
  return info
}

function combineShapeParts() {
  var idcombine = sTID("combine");
  var desc = new ActionDescriptor();
  var ref = new ActionReference();
  ref.putEnumerated(idPath, idOrdn, idTrgt);
  desc.putReference(idnull, ref);
  executeAction(idcombine, desc, DialogModes.NO);
}

function subtractFrontShape() {
  var idMrgtwo = cTID("Mrg2");
  var desc = new ActionDescriptor();
  var idshapeOperation = sTID("shapeOperation");
  var idSbtr = cTID("Sbtr");
  desc.putEnumerated(idshapeOperation, idshapeOperation, idSbtr);
  executeAction(idMrgtwo, desc, DialogModes.NO);
}

function uniteShapesAtOverlap() {
  var idMrgtwo = cTID("Mrg2");
  var desc = new ActionDescriptor();
  var idshapeOperation = sTID("shapeOperation");
  var idIntr = cTID("Intr");
  desc.putEnumerated(idshapeOperation, idshapeOperation, idIntr);
  executeAction(idMrgtwo, desc, DialogModes.NO);
}

function copyShapeAttributes() {
  var desc = new ActionDescriptor();
  var idshapeCopyShapeAll = stringIDToTypeID("shapeCopyShapeAll");
  desc.putEnumerated(idshapeClipboardOperation, idshapeClipboardOperation, idshapeCopyShapeAll);
  executeAction(idshapeClipboardOperation, desc, DialogModes.NO);
}

function pasteShapeAttributes() {
  var desc = new ActionDescriptor();
  var idshapePasteShapeAll = stringIDToTypeID("shapePasteShapeAll");
  desc.putEnumerated(idshapeClipboardOperation, idshapeClipboardOperation, idshapePasteShapeAll);
  executeAction(idshapeClipboardOperation, desc, DialogModes.NO);
}

function getActivePath() {
  try {
    var ref = new ActionReference()
    ref.putEnumerated(idPath, idOrdn, idTrgt)
    var desc = executeActionGet(ref)
    var theName = desc.getString(cTID("PthN"))
    return app.activeDocument.pathItems.getByName(theName)
  }
  catch (e) { return undefined }
}

// ------- Selection

function copySelectedPixels() {
  var idcopy = cTID("copy");
  executeAction(idcopy, undefined, DialogModes.NO);
}

/**
 * 
 * @param {*} bounds // x1, y1, x2, y2
 */
function select(bounds) {
  var idSbtF = cTID("SbtF");
  var desc = new ActionDescriptor();
  var ref = new ActionReference();
  ref.putProperty(idChnl, idfsel);
  desc.putReference(idnull, ref);

  var desc2 = new ActionDescriptor();
  desc2.putUnitDouble(idTop, idPxl, bounds[1]);
  desc2.putUnitDouble(idLeft, idPxl, bounds[0]);
  desc2.putUnitDouble(idBtom, idPxl, bounds[3]);
  desc2.putUnitDouble(idRght, idPxl, bounds[2]);

  desc.putObject(idT, idRctn, desc2);
  executeAction(idSbtF, desc, DialogModes.NO);
}

function selectionToChannel(name) {
  var doc = app.activeDocument;
  var channel = doc.channels.add();
  channel.name = name;
  channel.kind = ChannelType.SELECTEDAREA;
  doc.selection.store(channel, SelectionType.REPLACE);
  return channel
}

function isLayerSet(layer) {
  return layer.typename == 'LayerSet'
}

function contentAwareFill() {
  try { var SB = activeDocument.selection.bounds }
  catch (e) { return }
  var desc = new ActionDescriptor();
  desc.putEnumerated(cTID("Usng"), cTID("FlCn"), stringIDToTypeID("contentAware"))
  executeAction(cTID("Fl  "), desc, DialogModes.NO)
}

function invertSelection() {
  var idInvs = cTID("Invs");
  executeAction(idInvs, undefined, DialogModes.NO);
}

function deletePixels() {
  executeAction(idDlt, undefined, DialogModes.NO);
}

function deselect() {
  var desc = selectionDescriptor()
  desc.putEnumerated(idT, idOrdn, idNone);
  executeAction(idsetd, desc, DialogModes.NO);
}

function selectionFromMultipleRects(rects) {
  var doc = app.activeDocument
  var lineSubPathArray = new Array();
  for (var i = 0; i < rects.length; i++) {
    var rectLines = lineArrayFromRect(rects[i])
    lineSubPathArray[i] = new SubPathInfo;
    lineSubPathArray[i].operation = ShapeOperation.SHAPEADD;
    lineSubPathArray[i].closed = true;
    lineSubPathArray[i].entireSubPath = rectLines;
  }

  var myPathItem = doc.pathItems.add("path", lineSubPathArray);
  myPathItem.makeSelection()
  doc.pathItems.removeAll()
}

function transformPath(widthPercent, heightPercent, xOffset, yOffset) {
  var desc = targetPathDescriptor()
  transformDesc(desc, widthPercent, heightPercent, xOffset, yOffset)
}

function transformSelection(widthPercent, heightPercent, xOffset, yOffset) {
  var desc = selectionDescriptor()
  transformDesc(desc, widthPercent, heightPercent, xOffset, yOffset, true)
}

function transformDesc(desc, widthPercent, heightPercent, xOffset, yOffset, addLinkedKey) {
  var _addLinkedKey = addLinkedKey || false
  var idTrnf = cTID("Trnf");
  var idFTcs = cTID("FTcs");
  var idQCSt = cTID("QCSt");
  var idQcsa = cTID("Qcsa");
  desc.putEnumerated(idFTcs, idQCSt, idQcsa);
  var desc2 = new ActionDescriptor();

  xOffset = xOffset == undefined ? 0 : xOffset
  yOffset = yOffset == undefined ? 0 : yOffset

  desc2.putUnitDouble(idHrzn, idPxl, xOffset);
  desc2.putUnitDouble(idVrtc, idPxl, yOffset);
  desc.putObject(idOfst, idOfst, desc2);
  var idIntr = cTID("Intr");
  var idIntp = cTID("Intp");
  var idBcbc = cTID("Bcbc");
  if (heightPercent) {
    desc.putUnitDouble(idHght, idPrc, heightPercent);
    desc.putEnumerated(idIntr, idIntp, idBcbc);
  }
  if (widthPercent) {
    desc.putUnitDouble(idWdth, idPrc, widthPercent);
    desc.putEnumerated(idIntr, idIntp, idBcbc);
  }
  if (_addLinkedKey) {
    var idLnkd = cTID("Lnkd");
    desc.putBoolean(idLnkd, true);
  }
  executeAction(idTrnf, desc, DialogModes.NO);
}

// Rect = [x1,y1,x2,y2]
function lineArrayFromRect(rect) {
  var x1 = rect[0], y1 = rect[1], x2 = rect[2], y2 = rect[3]
  var f = 72 / app.activeDocument.resolution
  var A = [x1 * f, y1 * f]
  var B = [x2 * f, y1 * f]
  var C = [x2 * f, y2 * f]
  var D = [x1 * f, y2 * f]
  var rect = [A, B, C, D]

  var lineArray = new Array()

  for (var n = 0; n < rect.length; n++) {
    lineArray[n] = new PathPointInfo
    lineArray[n].kind = PointKind.CORNERPOINT
    lineArray[n].anchor = rect[n]
    lineArray[n].leftDirection = rect[n]
    lineArray[n].rightDirection = rect[n]
  };
  return lineArray
}

function selectionBoundsToNewLayer(bounds) {
  select(bounds)
  copySelectedPixels()
  pastePixels()
}

function selectionFromVisiblePixels() {
  var desc = new ActionDescriptor();
  var ref = new ActionReference();
  ref.putProperty(idChnl, idfsel);
  desc.putReference(idnull, ref);
  var ref2 = new ActionReference();
  var idTrsp = charIDToTypeID("Trsp");
  ref2.putEnumerated(idChnl, idChnl, idTrsp);
  desc.putReference(idT, ref2);
  executeAction(idsetd, desc, DialogModes.NO);
}

function selectionFromVectorMask() {
  var desc = new ActionDescriptor();
  var ref = new ActionReference();
  ref.putProperty(idChnl, idfsel);
  desc.putReference(idnull, ref);
  var ref2 = new ActionReference();
  var idvectorMask = sTID("vectorMask");
  ref2.putEnumerated(idPath, idPath, idvectorMask);
  ref2.putEnumerated(idLyr, idOrdn, idTrgt);
  desc.putReference(idT, ref2);
  var idVrsn = cTID("Vrsn");
  desc.putInteger(idVrsn, 1);
  var idvectorMaskParams = sTID("vectorMaskParams");
  desc.putBoolean(idvectorMaskParams, true);
  executeAction(idsetd, desc, DialogModes.NO);
}

function selectionFromVisible() {
  var lay = app.activeDocument.activeLayer
  if (isShapeLayer(lay)) {
    selectionFromVectorMask()
  } else {
    selectionFromVisiblePixels()
  }
}

function selectionHasPixel() {
  try {
    executeAction(sTID("copyEvent"), undefined, DialogModes.NO);
    return true
  } catch (e) { return false }
}

function pathFromSelection(tolerance) {
  tolerance = tolerance || 1
  var desc = new ActionDescriptor();
  var ref = new ActionReference();
  var idPath = cTID("Path");
  ref.putClass(idPath);
  desc.putReference(idnull, ref);
  var idFrom = cTID("From");
  var ref2 = new ActionReference();
  var idcsel = cTID("csel");
  ref2.putProperty(idcsel, idfsel);
  desc.putReference(idFrom, ref2);
  var idTlrn = cTID("Tlrn");
  desc.putUnitDouble(idTlrn, idPxl, tolerance);
  executeAction(idMk, desc, DialogModes.NO);
}

function contractSelection(px) {
  var idCntc = cTID("Cntc");
  var desc = new ActionDescriptor();
  var idBy = cTID("By  ");
  desc.putUnitDouble(idBy, idPxl, px);
  executeAction(idCntc, desc, DialogModes.NO);
}

function cutInSelection() {
  var idcut = charIDToTypeID("cut ");
  var desc3927 = new ActionDescriptor();
  var ref1981 = new ActionReference();
  ref1981.putProperty(idChnl, idfsel);
  desc3927.putReference(idnull, ref1981);
  var desc3928 = new ActionDescriptor();
  desc3928.putUnitDouble(idHrzn, idPxl, 0.000000);
  desc3928.putUnitDouble(idVrtc, idPxl, 0.000000);
  var idOfst = charIDToTypeID("Ofst");
  desc3927.putObject(idT, idOfst, desc3928);
  executeAction(idcut, desc3927, DialogModes.NO);
}

// ------- Masks

function copyMaskToLayers(fromLayer, toLayers) {
  var doc = app.activeDocument
  doc.activeLayer = fromLayer
  addMaskToSelection()
  var selection_channel = selectionToChannel("Stored Selection (" + fromLayer.name + ")")
  for (var i = 0; i < toLayers.length; i++) {
    doc.selection.load(selection_channel, SelectionType.REPLACE)
    doc.activeLayer = toLayers[i]
    if (hasLayerMask()) {
      doc.selection.invert()
      selectMask()
      fillBlack()
    } else {
      createNewMask()
    }
  }
  selection_channel.remove()
}

function selectMask() {
  var idslct = cTID("slct");
  var desc = new ActionDescriptor();
  var ref = new ActionReference();
  var idMsk = cTID("Msk ");
  ref.putEnumerated(idChnl, idChnl, idMsk);
  desc.putReference(idnull, ref);
  var idMkVs = cTID("MkVs");
  desc.putBoolean(idMkVs, false);
  executeAction(idslct, desc, DialogModes.NO);
}

function createNewMask() {
  _newMask(false)
}

function createNewMaskFromSelection() {
  _newMask(true)
}

function _newMask(fromSelection) {
  var desc = new ActionDescriptor();
  desc.putClass(idNw, idChnl);
  var idAt = cTID("At  ");
  var ref = new ActionReference();
  ref.putEnumerated(idChnl, idChnl, idMsk);
  desc.putReference(idAt, ref);
  var idUsng = cTID("Usng");
  var idUsrM = cTID("UsrM");
  var idRvlA = cTID("RvlA");
  var idRvlS = cTID("RvlS");
  var rvl = fromSelection ? idRvlS : idRvlA
  desc.putEnumerated(idUsng, idUsrM, rvl);
  executeAction(idMk, desc, DialogModes.NO);
}

function addMaskToSelection() {
  var desc = selectionDescriptor()
  var ref = new ActionReference();
  ref.putEnumerated(idChnl, idChnl, idMsk);
  desc.putReference(idT, ref);
  executeAction(idsetd, desc, DialogModes.NO);
}

function hasLayerMask() {
  var hasLayerMask = false;
  try {
    var ref = new ActionReference();
    var keyUserMaskEnabled = cTID('UsrM');
    ref.putProperty(cTID('Prpr'), keyUserMaskEnabled);
    ref.putEnumerated(idLyr, idOrdn, idTrgt);
    var desc = executeActionGet(ref);
    if (desc.hasKey(keyUserMaskEnabled)) {
      hasLayerMask = true;
    }
  } catch (e) {
    hasLayerMask = false;
  }
  return hasLayerMask;
}

function applyMask() {
  var idDlt = cTID("Dlt ");
  var desc = new ActionDescriptor();
  var ref = new ActionReference();
  ref.putEnumerated(idChnl, idOrdn, idTrgt);
  desc.putReference(idnull, ref);
  var idAply = cTID("Aply");
  desc.putBoolean(idAply, true);
  executeAction(idDlt, desc, DialogModes.NO);

}

// ------- Document

function newDocumentSameSettings(name) {
  var docSize = _docSize()
  app.documents.add(docSize.width, docSize.height, app.activeDocument.resolution, name, NewDocumentMode.rgb)
}

function _docSize() {
  usePixelUnits()
  var size = {
    width: app.activeDocument.width.as("px"),
    height: app.activeDocument.height.as("px")
  }
  resetUnits()
  return size
}

function getDocSizePx(dcmn) {
  usePixelUnits()
  var size = {
    width: dcmn.width.value,
    height: dcmn.height.value
  }
  resetUnits()
  return size
}

function duplicateActiveToDoc(targetDocName) {
  var desc = new ActionDescriptor();
  var ref = new ActionReference();
  ref.putEnumerated(idLyr, idOrdn, idTrgt);
  desc.putReference(idnull, ref);
  var ref2 = new ActionReference();
  ref2.putName(cTID('Dcmn'), targetDocName);
  desc.putReference(cTID('T   '), ref2);
  desc.putInteger(cTID('Vrsn'), 2);
  executeAction(cTID('Dplc'), desc, DialogModes.NO);
}

function trimTransparentPixel(top, right, bottom, left) {
  var idtrim = sTID("trim");
  var desc = new ActionDescriptor();
  var idtrimBasedOn = sTID("trimBasedOn");
  var idtrimBasedOn = sTID("trimBasedOn");
  var idTrns = cTID("Trns");
  desc.putEnumerated(idtrimBasedOn, idtrimBasedOn, idTrns);
  desc.putBoolean(idTop, top);
  desc.putBoolean(idBtom, bottom);
  desc.putBoolean(idLeft, left);
  desc.putBoolean(idRght, right);
  executeAction(idtrim, desc, DialogModes.NO);
}

function closeDocNoSave() {
  var idCls = cTID("Cls ");
  var desc = new ActionDescriptor();
  var idSvng = cTID("Svng");
  var idYsN = cTID("YsN ");
  var idN = cTID("N   ");
  desc.putEnumerated(idSvng, idYsN, idN);
  executeAction(idCls, desc, DialogModes.NO);
}

function closeDoc(save) {
  var idCls = cTID("Cls ");
  var desc = new ActionDescriptor();
  var idSvng = cTID("Svng");
  var idYsN = cTID("YsN ");
  if (save) {
    var idYs = cTID("Ys  ");
    desc.putEnumerated(idSvng, idYsN, idYs);
  } else {
    var idN = cTID("N   ");
    desc.putEnumerated(idSvng, idYsN, idN);
  }
  executeAction(idCls, desc, DialogModes.NO);
}

function getLastIndex(doc) {
  return getIndex(doc.layers[0])
}

function getDocumentBounds() {
  var docDesc = activeDocDescriptor()
  var width = getProperty(docDesc, idWdth)
  var height = getProperty(docDesc, idHght)
  return [0, 0, width, height]
}

function getActiveDocSizePx() {
  var docDesc = activeDocDescriptor()
  var resolution = getProperty(docDesc, idRslt)
  return {
    width: getProperty(docDesc, idWdth) * resolution / 72,
    height: getProperty(docDesc, idHght) * resolution / 72
  }
}

function getLayerSizePx(id) {
  var b = getBoundsById(id)
  return {
    width: b[2] - b[0],
    height: b[3] - b[1]
  }
}

function getDocumentById(id) {
  var docCount = app.documents.length
  for (var i = 0; i < docCount; i++) {
    var iDoc = app.documents[i]
    if (iDoc.id == id) {
      return iDoc
    }
  }
}

function resizeCanvas(width, height, extendColor, anchorPosH, anchorPosV) {
  var desc = new ActionDescriptor();
  if (width != undefined) {
    desc.putUnitDouble(idWdth, idPxl, width);
    desc.putEnumerated(idHrzn, idHrzL, anchorPosH);
  }
  if (height != undefined) {
    desc.putUnitDouble(idHght, idPxl, height);
    desc.putEnumerated(idVrtc, idVrtL, anchorPosV);
  }
  if (extendColor) {
    desc.putEnumerated(idcanvasExtensionColorType, idcanvasExtensionColorType, idClr);
    var colorDesc = colorDescriptor(extendColor.rgb.red, extendColor.rgb.green, extendColor.rgb.blue)
    desc.putObject(idcanvasExtensionColor, idRGBC, colorDesc);
  }
  executeAction(idCnvS, desc, DialogModes.NO);
}

function getArtboardDesc(layerDesc) {
  return layerDesc.getObjectValue(idartboard)
}

function setArtboardSize(id, width, height, anchorPointIndex) {

  var artboardDesc = getArtboardDesc(layerDescById(id))
  var b = getArtboardBounds(artboardDesc)
  var colorDesc = getColorDesc(artboardDesc)
  var newBounds = [b[0], b[1], b[2], b[3]]
  var xMid = (b[0] + b[2]) / 2
  var yMid = (b[1] + b[3]) / 2

  anchorPointIndex = anchorPointIndex | 0

  switch (anchorPointIndex) {
    case 1: newBounds[0] = xMid - width / 2; break;
    case 2: newBounds[0] = b[2] - width; break;
    case 3: newBounds[1] = yMid - height / 2; break;
    case 4: newBounds[0] = xMid - width / 2; newBounds[1] = yMid - height / 2; break;
    case 5: newBounds[0] = b[2] - width; newBounds[1] = yMid - height / 2; break;
    case 6: newBounds[1] = b[3] - height; break;
    case 7: newBounds[0] = xMid - width / 2; newBounds[1] = b[3] - height; break;
    case 8: newBounds[0] = b[2] - width; newBounds[1] = b[3] - height; break;
    default: break;
  }

  newBounds[2] = newBounds[0] + width
  newBounds[3] = newBounds[1] + height

  setArtboardBounds(newBounds, colorDesc)
}

function setArtboardBounds(bounds, colorDesc) {
  var ideditArtboardEvent = sTID("editArtboardEvent");
  var desc = new ActionDescriptor();
  var ref = new ActionReference();
  ref.putEnumerated(idLyr, idOrdn, idTrgt);
  desc.putReference(idnull, ref);

  var artboardDesc = new ActionDescriptor();
  var idartboardRect = sTID("artboardRect");
  var boundsDesc = new ActionDescriptor();
  boundsDesc.putDouble(idTop, bounds[1]);
  boundsDesc.putDouble(idLeft, bounds[0]);
  boundsDesc.putDouble(idBtom, bounds[3]);
  boundsDesc.putDouble(idRght, bounds[2]);
  var idclassFloatRect = sTID("classFloatRect");
  artboardDesc.putObject(idartboardRect, idclassFloatRect, boundsDesc);

  if (colorDesc) {
    artboardDesc.putObject(idClr, idRGBC, colorDesc);
  } else {
    var idartboardBackgroundType = sTID("artboardBackgroundType");
    artboardDesc.putInteger(idartboardBackgroundType, 1);
  }

  desc.putObject(idartboard, idartboard, artboardDesc);
  executeAction(ideditArtboardEvent, desc, DialogModes.NO);
}

function isArtBoard(desc) {
  return desc.getBoolean(sTID("artboardEnabled"));
}

function isArtBoardId(id) {
  var desc = layerDescById(id)
  return isArtBoard(desc)
}

function getArtboardBoundsById(id) {
  var desc = layerDescById(id)
  var artboardDesc = desc.getObjectValue(sTID("artboard"))
  return getArtboardBounds(artboardDesc)
}

function getArtboardBounds(artboardDesc) {
  var boundsDesc = artboardDesc.getObjectValue(sTID("artboardRect"));
  var right = boundsDesc.getDouble(idRght)
  var left = boundsDesc.getDouble(idLeft)
  var top = boundsDesc.getDouble(idTop)
  var bottom = boundsDesc.getDouble(idBtom)
  return [left, top, right, bottom]
}

function cropCanvas(bounds, deleteOutsidePixel) {
  var idCrop = charIDToTypeID("Crop");
  var desc = new ActionDescriptor();
  var boundsDesc = new ActionDescriptor();
  boundsDesc.putUnitDouble(idTop, idPxl, bounds[1]);
  boundsDesc.putUnitDouble(idLeft, idPxl, bounds[0]);
  boundsDesc.putUnitDouble(idBtom, idPxl, bounds[3]);
  boundsDesc.putUnitDouble(idRght, idPxl, bounds[2]);
  desc.putObject(idT, idRctn, boundsDesc);
  desc.putUnitDouble(idAngl, idAng, 0);
  desc.putBoolean(idDlt, deleteOutsidePixel);
  var idcropAspectRatioModeKey = stringIDToTypeID("cropAspectRatioModeKey");
  var idcropAspectRatioModeClass = stringIDToTypeID("cropAspectRatioModeClass");
  var idtargetSize = stringIDToTypeID("targetSize");
  desc.putEnumerated(idcropAspectRatioModeKey, idcropAspectRatioModeClass, idtargetSize);
  executeAction(idCrop, desc, DialogModes.NO);
}

function saveDocument(withThumbnail) {
  var doc = app.activeDocument
  var path
  try {
    path = doc.path
  } catch (e) { alert(e); return }

  var rememberedCompatibility = app.preferences.maximizeCompatibility
  if (withThumbnail) {
    app.preferences.maximizeCompatibility = QueryStateType.ALWAYS
  } else {
    app.preferences.maximizeCompatibility = QueryStateType.NEVER
  }
  var idsave = cTID("save");
  var desc = new ActionDescriptor();
  var idAs = cTID("As  ");
  var desc2 = new ActionDescriptor();
  var idmaximizeCompatibility = sTID("maximizeCompatibility");
  desc2.putBoolean(idmaximizeCompatibility, withThumbnail);
  var idPhtthree = cTID("Pht3");
  desc.putObject(idAs, idPhtthree, desc2);
  var idIn = cTID("In  ");
  desc.putPath(idIn, new File(path));
  var idDocI = cTID("DocI");
  desc.putInteger(idDocI, doc.id);
  var idsaveStage = sTID("saveStage");
  var idsaveStageType = sTID("saveStageType");
  var idsaveSucceeded = sTID("saveSucceeded");
  desc.putEnumerated(idsaveStage, idsaveStageType, idsaveSucceeded);
  executeAction(idsave, desc, DialogModes.NO);
  app.preferences.maximizeCompatibility = rememberedCompatibility
}

function getFileSize() {
  var size = 0
  try {
    var file = new File(app.activeDocument.fullName)
    size = file.length
  } catch (e) { }
  return size
}

function deleteCurrentHistoryState() {
  var desc = new ActionDescriptor();
  var ref = new ActionReference();
  var idHstS = cTID("HstS");
  var idCrnH = cTID("CrnH");
  ref.putProperty(idHstS, idCrnH);
  desc.putReference(idnull, ref);
  executeAction(idDlt, desc, DialogModes.NO);
}

function getToolID(){  
  var ref = new ActionReference();   
  ref.putEnumerated(cTID("capp"), idOrdn, idTrgt);   
  return executeActionGet(ref).getEnumerationType(sTID('tool'));   
}

function setTool(toolID) {
  var desc = new ActionDescriptor();
  var ref = new ActionReference();
  ref.putClass( toolID );
  desc.putReference( idnull, ref );
  executeAction(idslct, desc, DialogModes.NO);
}

// ------- Colors

function _grey() {
  return newColor(128, 128, 128)
}

function newColor(r, g, b) {
  var c = new SolidColor
  c.rgb.red = r
  c.rgb.green = g
  c.rgb.blue = b
  return c
}

function applySolidFillToActiveLayer(r, g, b) {
  var desc = targetLayerFxDescriptor()

  var desc2 = new ActionDescriptor();
  desc2.putUnitDouble(idScl, idPrc, 100.000000);

  var desc3 = new ActionDescriptor();
  desc3.putEnumerated(idMd, idBlnM, idNrml);

  var desc4 = new ActionDescriptor();
  desc4.putDouble(idRd, r);
  desc4.putDouble(idGrn, g);
  desc4.putDouble(idBl, b);

  desc3.putObject(idClr, idRGBC, desc4);
  desc3.putUnitDouble(idOpct, idPrc, 100.000000);

  desc2.putObject(idSoFi, idSoFi, desc3);
  desc.putObject(idT, idLefx, desc2);
  executeAction(idsetd, desc, DialogModes.NO);
}

function changeSolidColor(layerId, red, green, blue) {

  var desc = new ActionDescriptor();
  var ref = new ActionReference();
  ref.putIdentifier(idcontentLayer, layerId);
  desc.putReference(idnull, ref);

  var desc2 = new ActionDescriptor();
  desc2.putDouble(idRd, red);
  desc2.putDouble(idGrn, green);
  desc2.putDouble(idBl, blue);

  var desc3 = new ActionDescriptor();
  desc3.putObject(idClr, idRGBC, desc2);

  desc.putObject(idT, idsolidColorLayer, desc3);
  executeAction(idsetd, desc, DialogModes.NO);
}

function newColorLayer(color) {
  var desc = contentLayerDescriptor()

  var idUsng = cTID("Usng");
  var desc2 = new ActionDescriptor();
  var idType = cTID("Type");

  var desc4 = new ActionDescriptor();
  desc4.putDouble(idRd, color.rgb.red);
  desc4.putDouble(idGrn, color.rgb.green);
  desc4.putDouble(idBl, color.rgb.blue);

  var desc3 = new ActionDescriptor();
  desc3.putObject(idClr, idRGBC, desc4);

  desc2.putObject(idType, idsolidColorLayer, desc3);

  desc.putObject(idUsng, idcontentLayer, desc2);
  executeAction(idMk, desc, DialogModes.NO);
}

function fillWithForegroundColor() {
  var idFl = cTID("Fl  ");
  var desc = new ActionDescriptor();
  var idFlCn = cTID("FlCn");
  var idFrgC = cTID("FrgC");
  desc.putEnumerated(idUsng, idFlCn, idFrgC);
  desc.putUnitDouble(idOpct, idPrc, 100);
  desc.putEnumerated(idMd, idBlnM, idNrml);
  executeAction(idFl, desc, DialogModes.NO);
}

function fillBlack(preserveTransparency) {
  var _preserveTransparency = preserveTransparency || false
  var idFl = cTID("Fl  ");
  var desc = new ActionDescriptor();
  var idUsng = cTID("Usng");
  var idFlCn = cTID("FlCn");
  var idBlck = cTID("Blck");
  desc.putEnumerated(idUsng, idFlCn, idBlck);
  desc.putUnitDouble(idOpct, idPrc, 100.000000);
  desc.putEnumerated(idMd, idBlnM, idNrml);
  var idPrsT = cTID("PrsT");
  desc.putBoolean(idPrsT, _preserveTransparency);
  executeAction(idFl, desc, DialogModes.NO);
}

function fill(r, g, b, percent) {
  var idFl = cTID("Fl  ");
  var desc = new ActionDescriptor();
  var idUsng = cTID("Usng");
  var idFlCn = cTID("FlCn");

  desc.putEnumerated(idUsng, idFlCn, idClr);

  var desc2 = new ActionDescriptor();
  desc2.putDouble(idRd, r);
  desc2.putDouble(idGrn, g);
  desc2.putDouble(idBl, b);
  desc.putObject(idClr, idRGBC, desc2);

  desc.putUnitDouble(idOpct, idPrc, percent || 100);
  desc.putEnumerated(idMd, idBlnM, idNrml);
  executeAction(idFl, desc, DialogModes.NO);
}

function colorAt(x, y) {
  pointSample
  var pointSample = app.activeDocument.colorSamplers.add([x, y]);
  try {
    var color = pointSample.color
    pointSample.remove()
    return color
  } catch (e) {
    pointSample.remove()
    return undefined
  }
}

function colorDescriptor(r, g, b) {
  var color_desc = new ActionDescriptor();
  color_desc.putDouble(idRd, r);
  color_desc.putDouble(idGrn, g);
  color_desc.putDouble(idBl, b);
  return color_desc
}

function getLayerColorByID(id) {
  var ref = new ActionReference();
  ref.putProperty(idPrpr, sTID('color'));
  ref.putIdentifier(idLyr, id);
  return typeIDToStringID(executeActionGet(ref).getEnumerationValue(sTID('color')));
}

function getColorDesc(desc) {
  return getProperty(desc, idClr)
}


// ------- Styles

function scaleStylesOfIndices(layerIndices, percent) {
  for (var i = 0; i < layerIndices.length; i++) {
    if (layerIdxHasStyle(layerIndices[i])) {
      makeActiveByIndex(layerIndices[i], false)
      scaleActiveLayerEffects(percent)
    }
  }
}

function scaleActiveLayerEffects(percent) {
  var idscaleEffectsEvent = sTID("scaleEffectsEvent");
  var desc = new ActionDescriptor();
  desc.putUnitDouble(idScl, idPrc, percent);
  executeAction(idscaleEffectsEvent, desc, DialogModes.NO);
}

function layerHasStyle(layer) {
  var desc = layerDescById(layer.id)
  return desc.hasKey(sTID('layerEffects'))
}

function layerIdxHasStyle(index) {
  var desc = layerDescByIdx(index)
  return desc.hasKey(sTID('layerEffects'))
}

function setGlobalLight(angle, altitude) {
  var desc = new ActionDescriptor();
  var ref = new ActionReference();
  var idgblA = cTID("gblA");
  ref.putProperty(idPrpr, idgblA);
  ref.putEnumerated(idDcmn, idOrdn, idTrgt);
  desc.putReference(idnull, ref);
  var desc2 = new ActionDescriptor();
  var idgagl = cTID("gagl");
  desc2.putUnitDouble(idgagl, idAng, angle);
  var idglobalAltitude = sTID("globalAltitude");
  desc2.putUnitDouble(idglobalAltitude, idAng, altitude);
  desc.putObject(idT, idgblA, desc2);
  executeAction(idsetd, desc, DialogModes.NO);
}

function shadowDescriptor(colorDesc, opacity, angle, distance, blur, noise, antialias, hideBehindLayer, useGlobalLight) {
  var shadow_desc = new ActionDescriptor();
  shadow_desc.putBoolean(idenab, true);
  shadow_desc.putBoolean(idpresent, true);
  shadow_desc.putEnumerated(idMd, idBlnM, idNrml);
  shadow_desc.putObject(idClr, idRGBC, colorDesc);
  shadow_desc.putUnitDouble(idOpct, idPrc, opacity);
  shadow_desc.putBoolean(iduglg, useGlobalLight);
  shadow_desc.putUnitDouble(idlagl, idAng, angle);
  shadow_desc.putUnitDouble(idDstn, idPxl, distance);
  shadow_desc.putUnitDouble(idblur, idPxl, blur);
  shadow_desc.putUnitDouble(idNose, idPrc, noise);
  shadow_desc.putBoolean(idAntA, antialias);
  shadow_desc.putBoolean(idlayerConceals, hideBehindLayer);
  return shadow_desc
}

function innerShadowDescriptor(colorDesc, opacity, angle, distance, blur, noise, antiAlias) {
  var shadow_desc = new ActionDescriptor();
  shadow_desc.putBoolean(idenab, true);
  shadow_desc.putBoolean(idpresent, true);
  shadow_desc.putEnumerated(idMd, idBlnM, idNrml);
  shadow_desc.putObject(idClr, idRGBC, colorDesc);
  shadow_desc.putUnitDouble(idOpct, idPrc, opacity);
  shadow_desc.putBoolean(iduglg, false);
  shadow_desc.putUnitDouble(idlagl, idAng, angle);
  shadow_desc.putUnitDouble(idDstn, idPxl, distance);
  shadow_desc.putUnitDouble(idblur, idPxl, blur);
  shadow_desc.putUnitDouble(idNose, idPrc, noise);
  shadow_desc.putBoolean(idAntA, antiAlias);
  return shadow_desc
}

function hasLayerEffects(desc) {
  return desc.hasKey(sTID('layerEffects'))
}

function setFillOpacity(fillOpacity) {
  var desc = targetLayerDescriptor()
  var fillDesc = new ActionDescriptor();
  fillDesc.putUnitDouble(sTID('fillOpacity'), idPrc, fillOpacity);
  desc.putObject(idT, idLyr, fillDesc);
  executeAction(idsetd, desc, DialogModes.NO);
}

function setBlendMode(modeId) {
  var desc = targetLayerDescriptor()
  var blendDesc = new ActionDescriptor();
  blendDesc.putEnumerated(idMd, idBlnM, modeId);
  desc.putObject(idT, idLyr, blendDesc);
  executeAction(idsetd, desc, DialogModes.NO);
}

function setOpacity(opacity) {
  var desc = targetLayerDescriptor()
  var opacityDesc = new ActionDescriptor();
  opacityDesc.putUnitDouble(idOpct, idPrc, opacity);
  desc.putObject(idT, idLyr, opacityDesc);
  executeAction(idsetd, desc, DialogModes.NO);
}

function clearLayerStyle() {
  var iddisableLayerStyle = sTID("disableLayerStyle");
  var desc = targetLayerDescriptor()
  executeAction(iddisableLayerStyle, desc, DialogModes.NO);
}

function copyLayerStyle() {
  try {
    var idCpFX = cTID("CpFX");
    executeAction(idCpFX, undefined, DialogModes.NO);
    return true
  } catch (e) {return false}
}

function pasteLayerStyle() {
  try {
    var idPaFX = cTID("PaFX");
    executeAction(idPaFX, undefined, DialogModes.NO);
  } catch (e) {}
}

function addSolidColorStyle(color) {
  var desc = targetLayerFxDescriptor()
  var fxDesc = new ActionDescriptor();
  var fillDesc = new ActionDescriptor();
  var colorDesc = new ActionDescriptor();
  colorDesc.putDouble(idRd, color.rgb.red);
  colorDesc.putDouble(idGrn, color.rgb.green);
  colorDesc.putDouble(idBl, color.rgb.blue);
  fillDesc.putObject(idClr, idRGBC, colorDesc);
  fxDesc.putObject(idSoFi, idSoFi, fillDesc);
  desc.putObject(idT, idLefx, fxDesc);
  executeAction(idsetd, desc, DialogModes.NO)
}

// ------- Bounds, Sizes & Units

/**
 * @return bounds: [x1,y1,x2,y2]
 * @param {*} includeLayers 
 */
function getActivePixelBounds(includeLayers) {
  usePixelUnits()
  var bounds
  var selection = app.activeDocument.selection

  if (selection.active()) {
    bounds = pixelBounds(selection.bounds)
  } else if (includeLayers) {
    var selectedLayers = getSelectedLayers()
    if (selectedLayers.length) {
      bounds = getPixelBoundsFromLayers(selectedLayers)
    }
  } else {
    var doc = app.activeDocument
    bounds = pixelBounds([0, 0, doc.width, doc.height])
  }
  resetUnits()
  return bounds
}

function getPixelBoundsFromLayers(layers) {
  usePixelUnits()
  var bounds = []
  for (var i = 0; i < layers.length; i++) {
    bounds[0] = isNaN(bounds[0]) ? layers[i].bounds[0].as('px') : Math.min(bounds[0], layers[i].bounds[0]),
      bounds[1] = isNaN(bounds[1]) ? layers[i].bounds[1].as('px') : Math.min(bounds[1], layers[i].bounds[1]),
      bounds[2] = isNaN(bounds[2]) ? layers[i].bounds[2].as('px') : Math.max(bounds[2], layers[i].bounds[2]),
      bounds[3] = isNaN(bounds[3]) ? layers[i].bounds[3].as('px') : Math.max(bounds[3], layers[i].bounds[3])
  }
  resetUnits()
  return bounds
}

function pixelBounds(bounds) {
  usePixelUnits()
  var pxBounds = []
  var docSize = bounds[0].type == "%" ? _docSize() : undefined
  for (var i = 0; i < bounds.length; i++) {
    var uv = bounds[i]
    if (uv.type == "%") {
      uv.baseUnit = i == 0 || i == 2 ? UnitValue(docSize.width, "px") : UnitValue(docSize.height, "px")
    }
    pxBounds[i] = uv == 0 ? 0 : uv.as('px')
  }
  resetUnits()
  return pxBounds
}

function getActiveCenter(includeLayers) {
  usePixelUnits()
  var selectedLayers = getSelectedLayers()
  var sLength = selectedLayers.length
  var selection = app.activeDocument.selection
  var center
  if (selection.active()) {
    center = [
      (selection.bounds[0] + (selection.bounds[2] - selection.bounds[0]) / 2).as('px'),
      (selection.bounds[1] + (selection.bounds[3] - selection.bounds[1]) / 2).as('px')
    ]
  } else if (sLength && includeLayers) {
    var lBounds = getPixelBoundsFromLayers(selectedLayers)
    center = getCenterFromBounds(lBounds)
  } else {
    var docSize = _docSize()
    center = [
      docSize.width / 2,
      docSize.height / 2
    ]
  }
  resetUnits()
  return center
}

function getCenterFromBounds(bounds) {
  return [
    bounds[0] + (bounds[2] - bounds[0]) / 2,
    bounds[1] + (bounds[3] - bounds[1]) / 2
  ]
}

function boundsAreEmpty(bounds) {
  return (bounds[2] - bounds[0] == 0) || (bounds[3] - bounds[1] == 0)
}

/**
 * 
 * @param {*} layers 
 * @param {*} width true, height: false
 */
function getMultipleLayersSizeSum(layers, width) {
  var add = width ? 0 : 1
  var size = 0
  for (var i = 0; i < layers.length; i++) {
    var bounds = pixelBounds(layers[i].bounds)
    size += bounds[2 + add] - bounds[0 + add]
  }
  return size
}

function toPx(uvObj, percentBase) {
  usePixelUnits()
  if (uvObj.value == 0) {
    return 0
  }
  var uv = UnitValue(uvObj.value, uvObj.unit || 'px')
  if (uvObj.unit == '%') {
    var _percentBase = percentBase == undefined ? 1000 : percentBase
    var baseUnit = UnitValue(_percentBase, "px")
    uv.baseUnit = baseUnit
  }
  var pxVal = uv.as("px")
  resetUnits()
  return pxVal
}

function usePixelUnits() {
  rememberedUnits.push(app.preferences.rulerUnits)
  app.preferences.rulerUnits = Units.PIXELS
  setBaseUnit()
}

function setBaseUnit() {
  var res = app.activeDocument.resolution
  UnitValue.baseUnit = UnitValue(1 / res, "in")
}

function resetUnits() {
  app.preferences.rulerUnits = rememberedUnits[rememberedUnits.length - 1]
  rememberedUnits.pop()
}

function distanceBetweenBounds(b1, b2) {
  var center1 = boundsCenter(b1)
  var center2 = boundsCenter(b2)
  var a = center1[0] - center2[0];
  var b = center1[1] - center2[1];
  return Math.sqrt(a * a + b * b);
}

function boundsCenter(b) {
  return [(b[0] + b[2]) / 2, (b[1] + b[3]) / 2]
}

function getBoundsById(id) {
  var desc = layerDescById(id)
  var boundsDesc = getProperty(desc, idbounds)
  var left = getProperty(boundsDesc, idLeft)
  var right = getProperty(boundsDesc, idRght)
  var top = getProperty(boundsDesc, idTop)
  var bottom = getProperty(boundsDesc, idBtom)
  return [left, top, right, bottom]
}

function boundsNotRotated(bounds) {
  var b = bounds
  var samples = [
    [b[0], b[1], b[0] + 1, b[1] + 1], // topleft pixel
    [b[2] - 1, b[1], b[2], b[1] + 1], // topright pixel
    [b[2] - 1, b[3] - 1, b[2], b[3]], // bottomright pixel
    [b[0], b[3] - 1, b[0] + 1, b[3]] // bottomleft pixel
  ]

  for (var i = 0; i < samples.length; i++) {
    select(samples[i])
    if (!selectionHasPixel()) {
      noEmptyEdgePixel = false
      deselect()
      return false
    }
    deselect()
  }
  return true
}

// -------- Math

function angleFromMatrix(yy, xy) {
  var toDegs = 180 / Math.PI;
  return Math.atan2(yy, xy) * toDegs - 90;
}

function multiplicationRoundingQuot(multiplier, multiplicand) {
  var mResult = multiplier * multiplicand
  var roundingQuot = Math.round(mResult) / mResult
  return roundingQuot
}

function invertAngle(angle) {
  return angle >= 0 ? angle - 180 : angle + 180
}

function boundsToRect(b) {
  return {
    left: b[0],
    right: b[2],
    top: b[1],
    bottom: b[3],
  }
}

function getIntersectionArea(rect1, rect2) {
  var x_overlap = Math.max(0, Math.min(rect1.right, rect2.right) - Math.max(rect1.left, rect2.left));
  var y_overlap = Math.max(0, Math.min(rect1.bottom, rect2.bottom) - Math.max(rect1.top, rect2.top));
  return x_overlap * y_overlap;
}

function intersectRect(r1, r2) {
  return !(r2.left > r1.right ||
    r2.right < r1.left ||
    r2.top > r1.bottom ||
    r2.bottom < r1.top);
}

function intersectBounds(b1, b2) {
  return !(b2[0] > b1[2] ||
    b2[2] < b1[0] ||
    b2[1] > b1[3] ||
    b2[3] < b1[1]);
}

// -------- Smart Objects

function getSmartObjectRotation() {
  var points = getSmartObjectCorners();
  var w = points[0][0] - points[1][0];
  var h = points[0][1] - points[1][1];
  var angle = Math.atan(h / w) * 180.0 / Math.PI;
  return angle
}

function getSmartObjectCorners() {
  try {
    var r = targetLayerRef()
    var d;
    try { d = executeActionGet(r); } catch (e) { alert(e); return; }
    try { d = d.getObjectValue(sTID("smartObjectMore")); } catch (e) { alert(e); return; }
    try { d = d.getList(sTID("transform")); } catch (e) { alert(e); return; }
    var ret = [[d.getDouble(0), d.getDouble(1)],
    [d.getDouble(2), d.getDouble(3)],
    [d.getDouble(4), d.getDouble(5)],
    [d.getDouble(6), d.getDouble(7)]];
    return ret;
  }
  catch (e) { alert(e); }
}

function smartObjectInfo() {
  var r = targetLayerRef()
  var obj = executeActionGet(r).getObjectValue(sTID("smartObjectMore"))
  with (obj) {
    var _tmp;
    _tmp = getList(sTID("transform"));
    var transform = new Array();
    for (var i = 0; i < _tmp.count; i += 2) transform.push([_tmp.getDouble(i), _tmp.getDouble(i + 1)]);
    _tmp = getList(sTID("nonAffineTransform"));
    var nonAffineTransform = new Array();
    for (var i = 0; i < _tmp.count; i += 2) nonAffineTransform.push([_tmp.getDouble(i), _tmp.getDouble(i + 1)]);

    _tmp = getObjectValue(sTID("warp"));

    var warp = new Object({
      warpStyle: typeIDToStringID(_tmp.getEnumerationValue(sTID("warpStyle"))),
      warpValue: _tmp.getDouble(sTID("warpValue")),
      warpPerspective: _tmp.getDouble(sTID("warpPerspective")),
      warpPerspectiveOther: _tmp.getDouble(sTID("warpPerspective")),
      warpRotate: typeIDToStringID(_tmp.getEnumerationValue(sTID("warpRotate"))),
      uOrder: _tmp.getInteger(sTID("uOrder")),
      vOrder: _tmp.getInteger(sTID("vOrder")),

      bounds: new Object({
        top: _tmp.getObjectValue(sTID("bounds")).getUnitDoubleValue(sTID("top")),
        left: _tmp.getObjectValue(sTID("bounds")).getUnitDoubleValue(sTID("left")),
        bottom: _tmp.getObjectValue(sTID("bounds")).getUnitDoubleValue(sTID("bottom")),
        right: _tmp.getObjectValue(sTID("bounds")).getUnitDoubleValue(sTID("right")),
      }),
    });

    _tmp = getObjectValue(sTID("size"));
    var size = new Object({
      width: _tmp.getDouble(sTID("width")),
      height: _tmp.getDouble(sTID("height")),
    });
  }
  return {
    transform: transform,
    nonAffineTransform: nonAffineTransform,
    warp: warp.toSource(),
    size: size.toSource()
  }
}

function editContentsOfActiveSO() {
  var idplacedLayerEditContents = sTID("placedLayerEditContents");
  var desc = new ActionDescriptor();
  executeAction(idplacedLayerEditContents, desc, DialogModes.NO);
}

function createSmartObject() {
  try {
    var id325 = stringIDToTypeID("newPlacedLayer");
    executeAction(id325, undefined, DialogModes.NO);
  }
  catch (e) {
    alert("Failed to make smart object -" + e)
  }
}

// -------- Guides

function resetGuides() {
  var idclearAllGuides = sTID("clearAllGuides");
  executeAction(idclearAllGuides, undefined, DialogModes.NO);
}

/**
 * 
 * @param {*} orientation Vrtc (Vertical) or Hrzn (Horizontal)
 * @param {*} pixelposition 
 */
function createGuideLine(orientation, pixelposition) {
  var desc = new ActionDescriptor();
  var desc2 = new ActionDescriptor();
  desc2.putUnitDouble(idPstn, idPxl, pixelposition);
  var _orientation = cTID(orientation);
  desc2.putEnumerated(idOrnt, idOrnt, _orientation);
  var idGd = cTID("Gd  ");
  desc.putObject(idNw, idGd, desc2);
  executeAction(idMk, desc, DialogModes.NO);
}

function newGuideLayout(replace, colCount, colGutter, rowCount, rowGutter, marginTop, marginLeft, marginBottom, marginRight) {
  var desc = new ActionDescriptor();
  var desc2 = new ActionDescriptor();

  desc.putBoolean(sTID("replace"), replace);
  desc.putEnumerated(sTID("presetKind"), sTID("presetKindType"), sTID("presetKindCustom"));
  if (colCount) {
    desc2.putInteger(sTID("colCount"), colCount);
    desc2.putUnitDouble(sTID("colGutter"), idPxl, colGutter);
  }
  if (rowCount) {
    desc2.putInteger(sTID("rowCount"), rowCount);
    desc2.putUnitDouble(sTID("rowGutter"), idPxl, rowGutter);
  }
  if (marginTop) {
    desc2.putUnitDouble(sTID("marginTop"), idPxl, marginTop);
  }
  if (marginRight) {
    desc2.putUnitDouble(sTID("marginRight"), idPxl, marginRight);
  }
  if (marginBottom) {
    desc2.putUnitDouble(sTID("marginBottom"), idPxl, marginBottom);
  }
  if (marginLeft) {
    desc2.putUnitDouble(sTID("marginLeft"), idPxl, marginLeft);
  }
  desc.putObject(sTID("guideLayout"), sTID("guideLayout"), desc2);
  desc.putEnumerated(sTID("guideTarget"), sTID("guideTarget"), sTID("guideTargetCanvas"));
  executeAction(stringIDToTypeID("newGuideLayout"), desc, DialogModes.NO);
}

// ----------- Filter & Fx

function applyMotionBlur(angle, distance) {
  var desc = new ActionDescriptor();
  desc.putInteger(idAngl, angle);
  desc.putUnitDouble(idDstn, idPxl, distance);
  executeAction(idMtnB, desc, DialogModes.NO);
}

function applyGaussianBlur(radius) {
  var desc = new ActionDescriptor();
  desc.putUnitDouble(idRds, idPxl, radius);
  executeAction(idGsnB, desc, DialogModes.NO);
}

// ----------- Persistence


function eraseOptionKey(optionId, keyId) {
  var desc = app.getCustomOptions(optionId);
  if (desc !== null) {
    desc.erase(keyId);
    app.putCustomOptions(optionId, desc, true);
  }
}

function saveString(id, stringKey, string) {
  var desc = new ActionDescriptor();
  try {
    var existing = app.getCustomOptions(id)
    desc = existing
  } catch (e) { }

  desc.putString(stringKey, string);
  app.putCustomOptions(id, desc, true);
}

function resetCustomOptions(id) {
  var desc = new ActionDescriptor();
  app.putCustomOptions(id, desc, true);
}

function getSavedString(id, stringKey) {
  var string
  try {
    var desc = app.getCustomOptions(id);
    string = desc.getString(stringKey);
  } catch (e) { }
  return string
}























